##
## container.py
## Login : <uli@pu.smp.net>
## Started on  Thu Jan 20 04:33:18 2011 Uli Fouquet
## $Id$
## 
## Copyright (C) 2011 Uli Fouquet
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
## 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Containers for student applications.
"""
import grok
from waeup.sirp.applications.interfaces import IApplicationContainer

class ApplicationContainer(grok.Container):
    """An application container contains student applications.
    """
    grok.implements(IApplicationContainer)

    id = None
    title = None
    description = None
    startdate = None
    enddate = None
    strict_deadline = True

    def archive(self, app_ids=None):
        """Create on-dist archive of applications stored in this term.

        If app_ids is `None`, all applications are archived.

        If app_ids contains a single id string, only the respective
        applications are archived.

        If app_ids contains a list of id strings all of the respective
        application types are saved to disk.
        """
        raise NotImplemented()

    def clear(self, app_ids=None, archive=True):
        """Remove applications of type given by 'id'.

        Optionally archive the applications.
        
        If id is `None`, all applications are archived.

        If id contains a single id string, only the respective
        applications are archived.

        If id contains a list of id strings all of the respective
        application types are saved to disk.

        If `archive` is ``False`` none of the archive-handling is done
        and respective applications are simply removed from the
        database.
        """
        raise NotImplemented()
